<% @Page Language="C#" %>
<%@ Import Namespace="System.IO"%>

<script runat="server">

    private void Page_Load(object source, EventArgs e){
        /* Security fix: Missing X-Frame-Options */
        Response.AddHeader("X-Frame-Options", "DENY");
        savedConfigUrl.InnerHtml = getSavedMobileServerURL();
        //if (isDebugModeEnabled()) {
         //   debugMode.Checked = true;
       // }
    }

    private Boolean isValidURL(String strUrl) {
        Uri uriResult;
        return Uri.TryCreate(strUrl, UriKind.Absolute, out uriResult)
        && (uriResult.Scheme == Uri.UriSchemeHttp || uriResult.Scheme == Uri.UriSchemeHttps);      
    }

    private void onSubmit(object sender, EventArgs e) {
        
        // if (isEDMChecked()) {
        //     setDebugFlag(true);
        // }
        // else {
        //     setDebugFlag(false);
        // }
        //debugMode.Checked = isDebugModeEnabled();
        String urlString = "none";
        String urlConfig = getMobileConfigURL();
        if (!String.IsNullOrEmpty(urlConfig)){
            if (isValidURL(urlConfig.ToString())) {
                String mUrl = extractURL(urlConfig);
                if (!String.IsNullOrEmpty(mUrl)){                
                    insertMobileServerURL(mUrl.Trim());
                    urlString = getSavedMobileServerURL();
                } else {
                    urlString = "invalid url";
                }
            } else {
                urlString = "invalid url";
            }
        }
        savedConfigUrl.InnerHtml = urlString;
    }

    private String getPackageName() {
        return "VitaraMaps";
    }
    private String getPackageSampleChart(){
        return "VitaraMapsLibrary";
    }
    private Boolean belongsToPackage(String chart){
        Boolean result = false;
        if (chart.StartsWith("Vitara") && !chart.Equals(getPackageName())) {
            result = true;
        }
        if (getPackageName().Contains("Charts") && chart.Contains("VitaraMapsLibrary")) {
            result = false;
        }
        else if (getPackageName().Contains("Maps") && !chart.Contains("VitaraMapsLibrary")) {
            result = false;
        }
        return result;
    }
    private String getPluginsRoot(){
        return Server.MapPath("~") + "\\plugins\\";
        //return Server.MapPath("~");
    }
    private String getChartsRoot(){
        return getPluginsRoot() + "VitaraMapsLibrary\\";
    }
    private String getSourceRoot(){
        return getChartsRoot() + "javascript\\mojo\\js\\source\\";
    }
    private String getDebugFilePath(){
        return getPluginsRoot() + "VitaraHCBarChartMobile\\javascript\\mojo\\js\\source\\VitaraHCBarChartLibrary.js";
    }
    private String getMobileServerFilePath(String dir){
    	String SourceDirPath = getPluginsRoot() + dir + "\\javascript\\mojo\\js\\source\\";
    	List<string> dirs = new List<string>(Directory.EnumerateFiles (SourceDirPath));
        foreach(String aFile in dirs){
            return aFile;
        }

        return SourceDirPath + "MobileServerUrl.js";
    }
    private String getMobileConfigURL(){
        return mobileConfigUrl.Value;
    }
    private Boolean isEDMChecked(){
        return debugMode.Checked;
    }
    private String getRegExMatch(String config, String pattern){
        String result = "";
        MatchCollection matches = Regex.Matches(config, pattern);
        //temp as all regex yields single match.
        foreach(Match match in matches){
            result = match.ToString();
        }
        /* if(String.IsNullOrEmpty(result)){
            result = config;
        } */
        return result;
    }
    private String extractURL(String config){
        String result = getRegExMatch(config, "http.+?(?=servlet|api|asp)");
        if(!String.IsNullOrEmpty(result)){
            return result;
        } else {
            return config;
        }        
        return null;
    }
    private List<string> getDirs(String path){
        List<string> dirs = new List<string>(Directory.EnumerateDirectories(path));
        List<string> res = new List<string>();
        foreach(String dir in dirs){
            res.Add(dir.Substring(dir.LastIndexOf("\\") + 1));
        }
        return res;
    }
    private String readFile(String filePath){
        String text = "";
        using (StreamReader sr = new StreamReader(filePath)) {
                text = sr.ReadToEnd();
        }
        return text;
    }
    private void createFile(String path, String data){
        using (FileStream fs = File.Create(path)) {
            Byte[] info = new UTF8Encoding(true).GetBytes(data);
            fs.Write(info, 0, info.Length);
        }
    }
    private void deleteFile(String path){
        if (File.Exists(path)) {
            File.Delete(path);
        }
    }
    private String getStringUrlFun(String url, String dirName){
        return "(function(){if(!mstrmojo.plugins." + dirName + ") mstrmojo.plugins."+dirName+"={};mstrmojo.plugins."+dirName+".MobileServerUrl=Object;window.getMobileServerURL =  function getMobileServerURL(){return '" + url + "';}}());";
    }
    private String getStringUrlFun1(String url, String dirName){
        return "mstrmojo.plugins." + dirName + ".MobileServerUrl=Object;window.getMobileServerURL = function(){return '" + url + "';}";
    }
    private String getSavedMobileServerURL(){
        String result = "none";
        String fPath = getMobileServerFilePath(getPackageSampleChart());
        if (File.Exists(fPath)){
            String content = readFile(fPath);
            String matchContent = getRegExMatch(content, "(mstrmojo.plugins."+ getPackageSampleChart() +".MobileServerUrl=)([^}]+(?<!Object).)");
            if(!String.IsNullOrEmpty(matchContent)){                
                result = getRegExMatch(matchContent, "http.+?(?=';})");
            }
        }
        return result;
    }
    private Boolean isDebugModeEnabled(){
        String result = "false";
        String path = getDebugFilePath();
        String content = readFile(path);
        result = getRegExMatch(content, "(?<=var isVitaraMobileDebug = )true|false");
        return Boolean.Parse(result);
    }
    private Boolean isRegExMatch(String content, String regEx){
        return Regex.IsMatch(content, regEx);
    }
    private void setDebugFlag(Boolean mBool){
        String path = getDebugFilePath();
        String content = readFile(path);
        if (Regex.IsMatch(content, "var isVitaraMobileDebug\\s*=\\s*true|var isVitaraMobileDebug\\s*=\\s*false")) {
            if (mBool) {
                content = Regex.Replace(content, "var isVitaraMobileDebug\\s*=\\s*true|var isVitaraMobileDebug\\s*=\\s*false", "var isVitaraMobileDebug = true");
            }
            else {
                content = Regex.Replace(content, "var isVitaraMobileDebug\\s*=\\s*true|var isVitaraMobileDebug\\s*=\\s*false", "var isVitaraMobileDebug = false");                
            }
        }
        createFile(path, content);
    }
    private void updateMobileServerURL(String mServerURLString, String filePath, String dirName){
        

    	String fileContent = readFile(filePath);
    	String updatedFileString = "mstrmojo.plugins.VitaraHCMapChartLibrary.MobileServerUrl=function getMobileServerURL(){return '" + mServerURLString + "';}();";
    	String line = fileContent;
    	String pattern = "(mstrmojo.plugins.VitaraHCMapChartLibrary.MobileServerUrl=)([^}]+(?<!Object).)";
    	String String_final_str = "";
    	if(isRegExMatch(line, pattern)){
    		String m = getRegExMatch(line, pattern);
    		String_final_str = line.Replace(m, mServerURLString);
            if(!String.IsNullOrEmpty(String_final_str)){
                fileContent = String_final_str;
            }
    	}
    	createFile(filePath, fileContent);

    }
    private void insertMobileServerURL(String strUrl){
        List<String> dirs = getDirs(getPluginsRoot());
        if (strUrl != null) {
            foreach(String dir in dirs){
                if (belongsToPackage(dir)) {
        			

                    updateMobileServerURL(getStringUrlFun1(strUrl, dir), getMobileServerFilePath(dir), dir);
                }
            }
        }
    }
</script>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
        <style>
            .vtrButton {
                width: 80px;
                height: 25px;
            }

            .inputBox {
                width: 350px;
                height: 150px;
                box-sizing: border-box;
                border: 1px solid #e0e0e0;
                border-radius: 4px;
                background-color: #fcfcfc;
                padding: 3px;
                resize: none;
            }

            body {
                font-family: Arial, Helvetica, sans-serif;
                font-size: 14px;
            }

            label {
                color: blue;
            }
        </style>
    </head>
    <body>
        <form runat="server">
            <!-- <br> Enable Debug Mode:
            <input runat="server" type="checkbox" name="debugMode" id="debugMode">
            <br> -->
            <br> Mobile Configuration URL:
            <br>
            <textarea runat="server" type="text" name="mobileConfigUrl" id="mobileConfigUrl" class="inputBox"></textarea>
            <br>
            <label runat="server" id="savedConfigUrl">
            </label>
            <br>
            <br>
            <input runat="server" id="formSubmit" class="vtrButton" type="submit" value="Submit" OnServerClick="onSubmit">
        </form>
    </body>
</html>